"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _validator = _interopRequireDefault(require("./validator"));

var _visitorManager = _interopRequireDefault(require("./visitorManager"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var Configuration = function Configuration() {
  _classCallCheck(this, Configuration);

  _defineProperty(this, "configure", function (config) {
    var validator = config.validator,
        visitorManager = config.visitorManager;

    if (!validator && !visitorManager) {
      throw new Error("Configure in canner-script must have the following key: validator, visitorManager, but receive ".concat(JSON.stringify(config)));
    }

    if (validator) {
      _validator.default.setConfig(validator);
    }

    if (visitorManager) {
      var defaultVisitors = visitorManager.defaultVisitors,
          visitors = visitorManager.visitors;

      if (defaultVisitors) {
        _visitorManager.default.setDefaultVisitors(defaultVisitors);
      }

      if (visitors && visitors.length) {
        visitors.forEach(function (visitor) {
          _visitorManager.default.addVisitor(visitor);
        });
      }

      if (visitors && !visitors.length) {
        _visitorManager.default.resetVisitors();
      }
    }
  });
};

var _default = new Configuration();

exports.default = _default;