"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _basic = _interopRequireDefault(require("./basic"));

var _saferEval = _interopRequireDefault(require("safer-eval"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

var JsonModal =
/*#__PURE__*/
function (_BasicModel) {
  _inherits(JsonModal, _BasicModel);

  function JsonModal(attrs, children) {
    var _this;

    _classCallCheck(this, JsonModal);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(JsonModal).call(this, 'json', attrs));
    var builder = _this.attributes.builder;

    if (typeof builder === 'string') {
      builder = (0, _saferEval.default)(builder);
    }

    if (typeof builder === 'function') {
      // $FlowFixMe
      _this.toJson = function () {
        return builder({
          attributes: _objectSpread({}, attrs, {
            builder: undefined,
            type: 'json'
          }),
          children: children
        });
      };

      return _possibleConstructorReturn(_this, _assertThisInitialized(_assertThisInitialized(_this)));
    }

    if (children && children.length) {
      _this.attributes.items = children.reduce(function (result, child) {
        if (child.keyName in result) {
          throw new Error("duplicated keyName in children of ".concat(_this.attributes.keyName));
        }

        result[child.keyName] = child;
        return result;
      }, {});
    }

    return _this;
  }

  return JsonModal;
}(_basic.default);

exports.default = JsonModal;