"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _visitors = _interopRequireDefault(require("./visitors"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var VisitorManager = function VisitorManager() {
  var _this = this;

  _classCallCheck(this, VisitorManager);

  _defineProperty(this, "defaultVisitors", _toConsumableArray(_visitors.default));

  _defineProperty(this, "visitors", []);

  _defineProperty(this, "resetVisitors", function () {
    _this.visitors.length = 0;
  });

  _defineProperty(this, "addVisitor", function (visitor) {
    _this.visitors.push(visitor);
  });

  _defineProperty(this, "setDefaultVisitors", function (visitors) {
    _this.defaultVisitors = _toConsumableArray(visitors);
  });

  _defineProperty(this, "getAllVisitors", function () {
    return _toConsumableArray(_this.visitors).concat(_toConsumableArray(_this.defaultVisitors));
  });
};

var _default = new VisitorManager();

exports.default = _default;