"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/**
  these vistors handles the body layout that all first level components will move into
 */
var arrayBody = {
  'component.array': {
    exit: function exit(path) {
      if (path.node.pattern === 'array') {
        var routeMap = genRouteMap('', path.node);
        var componentInBody = {
          nodeType: 'layout.body',
          ui: "body",
          children: [{
            nodeType: 'layout.block',
            ui: "block",
            children: [path.node]
          }],
          routeMap: routeMap
        }; // remove title description to body container

        path.node.hideTitle = true;
        path.tree.setNode(path.route, componentInBody);
      }
    }
  }
};
var objectBody = {
  'component.object': {
    exit: function exit(path) {
      if (path.node.pattern === 'object') {
        var routeMap = genRouteMap('', path.node);
        var componentInBody = {
          nodeType: 'layout.body',
          ui: 'body',
          children: [{
            nodeType: 'layout.block',
            ui: "block",
            children: [path.node]
          }],
          routeMap: routeMap
        }; // hide first layer title decsription to body container

        path.node.hideTitle = true;
        path.tree.setNode(path.route, componentInBody);
      }
    }
  }
};
var pageBody = {
  'page.page': {
    exit: function exit(path) {
      var routeMap = genRouteMap('', path.node);
      var componentInBody = {
        nodeType: 'layout.body',
        ui: "body",
        children: [path.node],
        routeMap: routeMap
      }; // remove title description to body container

      path.node.hideTitle = true;
      path.tree.setNode(path.route, componentInBody);
    }
  }
};

function genRouteMap(currentRoute, node) {
  var routeMap = {};

  if (node.nodeType.indexOf('layout') === -1) {
    currentRoute = "".concat(currentRoute ? currentRoute + '/' : '').concat(node.name || '');
    routeMap[currentRoute] = {
      title: node.title,
      description: node.description
    };
  } // ARRAY_TYPE_PLACEHOLDER may be a index or index


  if (node.type === 'array' && (node.ui === 'tab' || node.ui === 'popup' || node.ui === 'breadcrumb')) {
    currentRoute = "".concat(currentRoute, "/[^/]*");
    routeMap[currentRoute] = {
      title: '編輯',
      description: ''
    };
  }

  (node.children || []).forEach(function (child) {
    var childMap = genRouteMap(currentRoute, child);
    routeMap = _objectSpread({}, routeMap, childMap);
  });
  return routeMap;
}

var _default = [arrayBody, objectBody, pageBody];
exports.default = _default;